﻿// Copyright © 1998, 2012, Oracle and/or its affiliates.  All rights reserved.

var TreeConfig = {
	AutoExpandLimit: 100,
	SearchResultLimit: 200
};

var PlayerConfig = {
	BaseUrl: "",
	TestItMode: false,
	AACIsAvailable: false,
	EnableCookies: true,
	DualMonitorSupport: false,
	DualMonitorFixedSize: false,
	StringInputAutoadvanceEnabled: true,
	StringInputLostFocusAutoadvanceEnabled: true,
	InfoWidth: 400,
	InfoHeight: 300,
	InfoWidth2: 640,
	InfoHeight2: 480,
	ShowScoreNeeded: true,
	PreloadScreenEnabled: true,
	HideClickMark: false,

	// If TrackFeedBack equals false, the scoring screen will not appear at the end of a topic:
	TrackFeedBack: true,
	MouseDelay: 100,
	MinMouseDelay: 50,
	BullseyeDelay: 150,
	InputDelay: 200,
	WheelDelay: 500,
	PausedDelay: 500,
	MouseSteps: 30,
	PanSpeed: 8,
	AllowRandomAnswersForMatchingQuestions: true,
	ShowFrameID: "Off",
	HideActionBordersInSeeIt: false,
	UseCursorShadow: true
};

var LmsConfig = {

	// The AICC spec is unclear on what protocol should be used as the default when no protocol specified in the AICC_URL. The following can be configured to enable https configurations. Note that this is ignored if the LMS passes the protocol on the AICC_URL.
	AiccUrlProtocol: "http://",

	// If the LMS requires a specific AICC version and does not accept 3.5, this can be configured to specify an AICC version that is supported by the LMS. While OnDemand has been tested with the AICC 3.5 specification, versions back to 2.0 should work without difficulty.
	AiccVersion: 3.5,

	// The following can be used to solve cross domain problems encountered in Java when the LMS is on one host and the content on another. Move the file /scripts/GetHTTPPostData.class to a location on the LMS and configure the appletPath to point to the location of this file. Example: var appletPath = 'http://127.0.0.1:81';
	AiccAppletPath: "",

	// The following can be enabled to allow all LMS communication messages to be shown within the page. This can be used for diagnosing LMS -&gt; Content communication problems
	DebugMode: false,

	// Set the SCORM version for adapter searching.
	ScormVersion: "auto",

	// These two settings allow you to control what completion/sucess status is reported to the LMS on completion of a graded item (passed/failed/completed/incomplete).
	ReportOnPass: "passed",
	ReportOnFail: "failed"
};
